# -*- coding: utf-8 -*-

from typing import List


def merge_sort(array: List):
    # The last array split...
    if len(array) <= 1:
        return array

    # Perform merge_sort recursively on both halves...
    mid = len(array) // 2
    left, right = merge_sort(array[:mid]), merge_sort(array[mid:])

    # Merge each side together...
    return merge(left, right, array.copy())


def merge(left, right, merged):
    left_cursor, right_cursor = 0, 0

    while left_cursor < len(left) and right_cursor < len(right):
        # Sort each one and place into the result...
        if left[left_cursor] <= right[right_cursor]:
            merged[left_cursor + right_cursor] = left[left_cursor]
            left_cursor += 1

        else:
            merged[left_cursor + right_cursor] = right[right_cursor]
            right_cursor += 1

    for left_cursor in range(left_cursor, len(left)):
        merged[left_cursor + right_cursor] = left[left_cursor]

    for right_cursor in range(right_cursor, len(right)):
        merged[left_cursor + right_cursor] = right[right_cursor]

    return merged
